/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.renderer.html;

import java.io.IOException;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.jmx.component.UIJMXPortlet;
import org.exoplatform.portlets.jmx.component.UINavigator;
/**
 * Jul 29, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: JMXPortletRenderer.java,v 1.2 2004/08/02 17:36:45 benjmestrallet Exp $
 */
public class JMXPortletRenderer extends HtmlBasicRenderer {
	public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
		UIJMXPortlet uiPortlet = (UIJMXPortlet) component ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext()) ;
    List children = uiPortlet.getChildren() ;
    ResponseWriter w = context.getResponseWriter() ;
    String colspan = Integer.toString(children.size()) ;
    w.write("<table class='"); w.write(uiPortlet.getClazz()); w.write("'>") ;
    w. write("<tr>");
    w.  write("<td class='header' colspan='"); w.write(colspan); w.write("'>") ;
    w.    write(res.getString("UIJMXPortlet.header.title"));
    w.  write("</td>");
    w. write("</tr>");
    w. write("<tr>");
    for(int i = 0 ; i < children.size(); i++) {
      UIExoComponent uiChild = (UIExoComponent) children.get(i) ;
      if(((UIComponent)uiChild).isRendered()){
        if(uiChild instanceof UINavigator) {
      	  w.  write("<td valign='top' class='"); w.write(uiChild.getClazz());  w.write("'>") ;
        } else {
          w.  write("<td valign='top'> ");
        }
        uiChild.encodeBegin(context) ;
        uiChild.encodeChildren(context) ;
        uiChild.encodeEnd(context) ;
        w.  write("</td>");
      }
    }
    w. write("</tr>");
    w. write("<tr>");
    w.  write("<td class='footer' colspan='"); w.write(colspan); w.write("'>") ;    
    w.  write("</td>");
    w. write("</tr>");
    w.write("</table>") ; 
	}	
}
